/* file KUT/kutmain.c */
/* Time-stamp: <1998 Augu 24 Mon 22:17:07 CEST Basile.Starynkevitch@wanadoo.fr> */
/* rcsid: $Id: kutmain.c,v 0.5 1998/08/24 20:18:31 basile Exp $ */

#include "kut.h"

const char kutmain_ident[] =
 "@(#)$Id: kutmain.c,v 0.5 1998/08/24 20:18:31 basile Exp $"
 " <" __DATE__ "@" __TIME__ ">";

const char kut_h_ident[] = KUT_H_IDENT " <" __DATE__ "@" __TIME__ ">";

void panic_at(char* fil, int lin, char *msg)  {
  scr_maybenl();
  scr_setattr(SCR_ATTR_NORM);
  scr_c_show("$PANIC @");
  scr_c_show(fil);
  scr_c_show(":");
  scr_show_decint(lin);
  scr_c_show(" ");
  scr_c_show(msg);
  scr_c_show(" ");
  scr_nl();
  cli();
  asm volatile("1: nop; hlt; nop; jmp 1b; nop");
}

void panic_at_int(char* fil, int lin, char *msg, int nb)  {
  scr_maybenl();
  scr_setattr(SCR_ATTR_NORM);
  scr_c_show("$PANIC @");
  scr_c_show(fil);
  scr_c_show(":");
  scr_show_decint(lin);
  scr_char_show(' ');
  scr_c_show(msg);
  scr_char_show(' ');
  scr_show_decint(nb);
  scr_c_show("(dec); ");
  scr_nl();
  cli();
  asm volatile("1: nop; hlt; nop; jmp 1b; nop");
}


void panic_at_word(char* fil, int lin, char *msg, unsigned nb)  {
  scr_maybenl();
  scr_setattr(SCR_ATTR_NORM);
  scr_c_show("$PANIC @");
  scr_c_show(fil);
  scr_c_show(":");
  scr_show_decint(lin);
  scr_char_show(' ');
  scr_c_show(msg);
  scr_char_show(' ');
  scr_show_hexword(nb);
  scr_c_show("(hex). ");
  scr_nl();
  cli();
  asm volatile("1: nop; hlt; nop; jmp 1b; nop");
}

extern void try_breakpoint(void);

extern char kut_timestamp[];

void kut_main(void)
{
  reqid_t rqid;
  unsigned res=0;
  int i;
  int oldy;
#ifdef KUT_DEBUG
  for (i=0; i<25; i++) {
    scr_setpos(70,22);
    scr_char_show('a'+i);
    /* a delay loop */
    for (res=10*1000*1000; res>0; res--) {
      asm volatile ("nop; nop");
    };
  };
  scr_clear();
  scrs_ssn("KUT built on ", kut_timestamp);
#endif /*KUT_DEBUG*/
  init_memory();
  init_interrupts();
  init_keyboard();
#ifdef KUT_DEBUG
  scrs_sn("trying breakpoint");
  try_breakpoint();		/* [see kutx86.S] in assembler call INT3 */
#endif /*KUT_DEBUG*/
  scrs_sn("main accepting interrupts");
  sti();
  scrs_sn("main entering dummy request loop");
  for (i=0;;i++) {
    oldy=scr_posy();
    scr_setpos(63,21);
    scrs_sin("MLOOP#",i);
    scr_setpos(0,oldy);
    /* a delay loop */
    for (res=10*1000*1000; res>0; res--) {
      asm volatile ("nop; nop");
    };
    rqid = request_wait_any(&res);
    asm volatile ("nop");
  };
} 

/*** rcslog
 ** $Log: kutmain.c,v $
 ** Revision 0.5  1998/08/24 20:18:31  basile
 ** the main request loop seems done only once... but timer go indefinitely
 **
 ** Revision 0.4  1998/08/23 11:08:36  basile
 ** why no keyboard interrupts?
 **
 ** Revision 0.3  1998/08/22 21:21:23  basile
 ** dummy request loop
 **
 ** Revision 0.2  1998/07/18 22:05:22  basile
 ** added panic routines
 **
 ** Revision 0.1  1998/07/16 17:54:36  basile
 *** endlog ****/

/* eof $Header: /home/basile/KUT/RCS/kutmain.c,v 0.5 1998/08/24 20:18:31 basile Exp $ */
