/* file KUT/kutmem.c */
/* Time-stamp: <1998 Augu 24 Mon 20:22:48 CEST Basile.Starynkevitch@wanadoo.fr> */
/* rcsid: $Id: kutmem.c,v 0.5 1998/08/24 20:19:13 basile Exp $ */

#include "kut.h"


const char kutmem_ident[] = 
 "@(#)$Id: kutmem.c,v 0.5 1998/08/24 20:19:13 basile Exp $ "
 "<" __DATE__ "@" __TIME__ ">";


struct sys_desc gdt[256] = { 
  /* #0 == null */ 
  { 0, 0, 0, 0, 0, 0 },
  /* #1 == kernel code; base: 0x00000000 limit: 0xFFFFFFFF (4GB-1) */
  { /* limit 0-16 */        0xFFFF, 
    /* base 0-15 */         0x0000, 
    /* base 16-23 */        0x00, 
    /* access */            (A_PRESENT | A_DPL_0 | A_CODE_READ), 
    /* gd, limit 16-19 */   (SEG_PAGED | SEG_32 | 0xF),
    /* base 24-31 */        0x00
  },
  /* #2 ==kernel data; base: 0x00000000 limit: 0xFFFFFFFF (4GB-1) */
  { /* limit 0-16 */        0xFFFF, 
    /* base 0-15 */         0x0000, 
    /* base 16-23 */        0x00, 
    /* access */            (A_PRESENT | A_DPL_0 | A_DATA_WRITE), 
    /* gd, limit 16-19 */   (SEG_PAGED | SEG_32 | 0xF),
    /* base 24-31 */        0x00
  },
};

struct pseudo_desc gdt_desc = {
  /* pad= */ 0, /* len= */sizeof(gdt) - 1, /* base= */(ulong)&gdt };

inline static void
load_gdt(struct pseudo_desc* pdesc) {
	asm volatile ("lgdt %0" : : "m" (pdesc->len));
}

extern int _endrounded[];
void init_memory(void) {
  int x;
  int y;
  int mega;
  load_gdt(&gdt_desc);	/* reload segment registers */
  asm volatile ("ljmp %0, $1f\n\t"
		"1: nop"
		: : "i" (GDTSEL_KCODE) );
  asm volatile("movl %0, %%eax\n\t"
	       "movw %%ax, %%ds\n\t"
	       "movw %%ax, %%es\n\t"
	       "movw %%ax, %%ss\n\t"
	       "movw %%ax, %%fs\n\t"
	       "movw %%ax, %%gs"
	       : : "i" (GDTSEL_KDATA) );
  /* clear low memory from 0 to 640M */
#ifdef KUT_DEBUG
  scrs_sn("clearing low memory");
#endif /*KUT_DEBUG*/
  memset((void*)0, 0, 640*1024);
  /* clear memory from _end to 16M */
#ifdef KUT_DEBUG
  scr_c_show(" clearing memory ");
  x = scr_posx();
  y = scr_posy();
#endif /*KUT_DEBUG*/
  memset(_endrounded, 0, 2*1024*1024 - (unsigned)(&_endrounded));
  for (mega=2; mega<16; mega++) {
#ifdef KUT_DEBUG
    scr_setpos(x,y);
    scr_show_decint(mega);
    scr_c_show("M.      ");
#endif /*KUT_DEBUG*/
    memset((void*)(mega<<20), 0, 1024*1024);
  };
#ifdef KUT_DEBUG
  scr_maybenl();
  scrs_sn("[kutmem.c $Revision: 0.5 $] memory initialized!");
#endif /*KUT_DEBUG*/
} /* end of init_memory */

/*** rcslog ***
 $Log: kutmem.c,v $
 Revision 0.5  1998/08/24 20:19:13  basile
 adding zero-ing of most memory ...

 Revision 0.4  1998/08/23 11:09:08  basile
 added ident string

 Revision 0.3  1998/08/22 21:21:45  basile
 debug message

 Revision 0.2  1998/07/18 22:07:07  basile
 added low level GDT initialization
 
 *** endlog ***/

/* eof $Header: /home/basile/KUT/RCS/kutmem.c,v 0.5 1998/08/24 20:19:13 basile Exp $ */
