/* file KUT/tuk86.S */
/* Time-stamp:	 <1998 Sept 02 Wed 21:49:09 CEST Basile.Starynkevitch@wanadoo.fr> */
/* rcsid: $Id: kutx86.S,v 0.6 1998/09/02 20:30:53 basile Exp $ */
	/* some code taken from VSTa or TINOS or GRUB */


	
	

/* Align on 4k, give mem info, mem parameters supplied */
#define MULTIBOOT_OPTS (MULTIBOOT_PAGE_ALIGN+MULTIBOOT_MEMORY_INFO+\
		MULTIBOOT_AOUT_KLUDGE)

/* Magic value identifying the multiboot_header.  */
#define MULTIBOOT_MAGIC		0x1badb002

/* Features flags for 'flags'.
   If a boot loader sees a flag in MULTIBOOT_MUSTKNOW set
   and it doesn't understand it, it must fail.  */
#define MULTIBOOT_MUSTKNOW	0x0000ffff

/* Align all boot modules on page (4KB) boundaries.  */
#define MULTIBOOT_PAGE_ALIGN	0x00000001

/* Must be provided memory information in multiboot_info structure */
#define MULTIBOOT_MEMORY_INFO	0x00000002

/* Use the load address fields above instead of the ones in the a.out header
   to figure out what to load where, and what to do afterwards.
   This should only be needed for a.out kernel images
   (ELF and other formats can generally provide the needed information).  */
#define MULTIBOOT_AOUT_KLUDGE	0x00010000

/* The boot loader passes this value in register EAX to signal the kernel
   that the multiboot method is being used */
#define MULTIBOOT_VALID         0x2badb002


	_multiboot_header:

	/*
	 * Multiboot header
	 */
	.long	MULTIBOOT_MAGIC		/* Magic */
	.long	MULTIBOOT_OPTS		/* Options */
	.long	(~0-(MULTIBOOT_MAGIC+MULTIBOOT_OPTS))+1 
	/* DON't WORK .long   -(MULTIBOOT_MAGIC+MULTIBOOT_OPTS) */
					/* Checksum */
	.long	_multiboot_header			/* Addr of this header */
	.long	__text_start			/*  ...start of text */
	.long	_edata			/*  ...end of data */
	.long	_end			/*  ...end of program */
	.long   kut_entry           /*  ...entry point */

	
	.text
	
	
__text_start:	
		.global kut_entry
kut_entry:	

	/* EBX has a multiboot_info, which our C code will peruse */
	movl	%ebx,boot_info_ptr

	/* Call our first C code on the start stack */
	movl	$_start_stack,%esp
	movl	$_start_stack,%ebp

	/* Set our machine flags to something reasonable */
	pushfl
	popl	%eax
/*
 * Bits in eflags
 */
#define	F_CF	0x00000001	/* carry */
#define	F_PF	0x00000004	/* parity */
#define	F_AF	0x00000010	/* BCD stuff */
#define	F_ZF	0x00000040	/* zero */
#define	F_SF	0x00000080	/* sign */
#define	F_TF	0x00000100	/* single step */
#define	F_IF	0x00000200	/* interrupts */
#define	F_DF	0x00000400	/* direction */
#define	F_OF	0x00000800	/* overflow */
#define	F_IOPL	0x00003000	/* IO privilege level */
#define	F_NT	0x00004000	/* nested task */
#define	F_RF	0x00010000	/* resume flag */
#define	F_VM	0x00020000	/* virtual 8086 */

	andl	$~(F_DF|F_NT|F_RF),%eax
	pushl	%eax
	popfl

	call	kut_main
3:	
	hlt
	hlt
	hlt
	jmp 3b
	nop
	.align 16
	.global start86_ident

start86_ident:	.asciz "@(#)$Id: kutx86.S,v 0.6 1998/09/02 20:30:53 basile Exp $"
	
	.data
	.align	4
	.space	0x30
	.long 0,0,0,0	
	.align 16
_start_stack:
	.space	48*1024
_stack_top:
	.long 0xBadBeef
	.long 0,0,0,0
	.space 0x10
	.align 16
	
	/* the boot info pointer is saved here */
	.global boot_info_ptr
boot_info_ptr:
	.long 0

	.globl	_start_stack, _stack_top	

	.text
	.skip 8
	.align 16
	.globl try_breakpoint
try_breakpoint:	
	int $3
	ret

	
/* much code taken from Bart Sekura's TINOS machtrap.S file */
	
/* generic macros to save/restore all registers except EAX&ECX (already saved?) */
#define SAVE_MOSTREGS			 \
	pushl	%edx			;\
	pushl	%ebx			;\
	pushl	%ebp			;\
	pushl	%esi			;\
	pushl	%edi			;\
	pushw	%ds			;\
	pushw	%es			;\
	movw	%ss, %ax		;\
	movw	%ax, %ds		;\
	movw	%ax, %es

#define RESTORE_MOSTREGS	 \
	popw	%es		;\
	popw	%ds		;\
	popl	%edi		;\
	popl	%esi		;\
	popl	%ebp		;\
	popl	%ebx		;\
	popl	%edx		


/* same macro to save/restore all registers (including EAX&ECX) */
#define SAVE_ALLREGS              \
	pushl   %eax		; \
	pushl   %ecx		; \
	SAVE_MOSTREGS

#define RESTORE_ALLREGS           \
	RESTORE_MOSTREGS        ; \
	popl    %ecx		; \
	popl    %eax


/* macros for generating entry points for cpu traps and interrupts
 * we push supplied code value for ones without it */
#define ENTRY(name, code)	\
	.globl int_##name	;\
	.align 4 		;\
int_##name:			;\
	pushl $code		;\
	cld			;\
	nop			;\
	SAVE_ALLREGS


#define ENTRY_WITH_ERROR(name)	\
	.globl int_##name	;\
	.align 4 		;\
int_##name:			;\
	cld			;\
	nop			;\
	SAVE_ALLREGS

/* leaving is the same for every trap type
 * we adjust stack pointer because of error code (or custom code) */
#define LEAVE_INT		\
	RESTORE_ALLREGS		;\
	addl $4, %esp		;\
	iret
	
/* interrupt routines int* with error code - handler called with
   struct frame_st  */
	
#define INTERRHANDLER(Nam,Rank)	       \
	ENTRY_WITH_ERROR(Nam)	    ;  \
	call handle_##Nam	    ;  \
	LEAVE_INT
	

/* interrupt handlers without error code - - handler called with
   struct frame_st  */
#define INTHANDLER(Nam,Rank)  	       \
	ENTRY(Nam,0)	            ;  \
	call handle_##Nam	    ;  \
	LEAVE_INT

/* external primary interrupt handler - should also output 0x20 to
   primary PIC port 0x20 */
	
#define IRQAHANDLER(Nam,Rank)       \
	ENTRY(Nam, 0)	        ;   \
	nop			;\
	movl $0x20, %eax	;   \
	outb %al, $0x20		;   \
	nop			;   \
	call handle_##Nam	;   \
	LEAVE_INT
	
/* external secondary interrupt handler - should also output 0x20 to
   primary PIC port 0x20 and secondary PIC port 0xA0 */
	
#define IRQBHANDLER(Nam,Rank)       \
	ENTRY(Nam, 0)	;\
	nop			;\
	movl $0x20, %eax	;\
	outb %al, $0x20		;\
	nop			;\
	outb %al, $0xA0		;\
	nop			;\
	call handle_##Nam	;\
	LEAVE_INT
	
#include "interr.tab"

/*** rcslog ***
 * $Log: kutx86.S,v $
 * Revision 0.6  1998/09/02 20:30:53  basile
 * still don't work, but I added nops
 *
 * Revision 0.5  1998/08/30 09:19:55  basile
 * much stuff from Tinos
 *
 * Revision 0.4  1998/08/28 21:47:19  basile
 * added IRQA &IRQB handlers
 * should push/pop all registers in handlers
 *
 * Revision 0.3  1998/08/24 18:15:45  basile
 * interrupt handler should pop its arguments
 *
 *** endlog ***/
 
/* eof $Header: /home/basile/KUT/RCS/kutx86.S,v 0.6 1998/09/02 20:30:53 basile Exp $ */